function [L, para_out, lambda, sigma, mu, l, x, L_check, mu_check, sigma_check] = ...
    log_likelihood_main(para, c, y, restrict, no_mu, check_l, min_lambda, max_lambda, cap_para)
% This is the joint log-likelihood function
% version: 2013/Apr/22 7:53 PM NY

if nargin == 4
    no_mu = 0;
    check_l = 1;
    min_lambda = zeros(length(para),1);
    max_lambda = ones(length(para),1);
    cap_para = 1000;    
elseif nargin == 5;
    check_l = 1;
    min_lambda = zeros(length(para),1);
    max_lambda = ones(length(para),1);
    cap_para = 1000;    
elseif nargin == 6;
    min_lambda = zeros(length(para),1);
    max_lambda = ones(length(para),1);    
    cap_para = 1000;
elseif nargin == 7;
    max_lambda = ones(length(para),1);    
    cap_para = 1000;
elseif nargin == 8;
    cap_para = 1000;
end

[T, N] = size(c);

lambda = restrict*(min_lambda + (max_lambda - min_lambda)./(1 + exp(para))) + (1-restrict)*min(cap_para*10, max(-cap_para*10, para));

%if ~isempty(lambda_replace);
%    for i = 1 : length(lambda)
%        if lambda(i,1) < lambda_replace;
%            lambda(i,1) = lambda_replace;
%        elseif 1 - lambda(i,1) < lambda_replace;
%            lambda(i,1) = 1 - lambda_replace;
%        end
%    end
%end

M = size(lambda,2);

L = NaN(M,1);
l = NaN(N,M);
sigma = NaN(N,M);
mu = zeros(N,M);

L_check = NaN(M,1);
sigma_check = NaN(N,M);
mu_check = zeros(N,M);

if no_mu == 1;
    para_out = [lambda; sigma];
else
    para_out = [lambda; mu; sigma];
end

for ii = 1 : M
    d = lambda(:,ii)/sum(lambda(:,ii));
    
    mu(:,ii) = (1-no_mu)*sum(c - y - ((ones(T,1)*lambda(:,ii)').*(- y + ((y*d)*ones(1,N)))))'/T;
    
    sigma(:,ii) = sqrt((sum((c - y - ones(T,1)*mu(:,ii)' - ((ones(T,1)*lambda(:,ii)').*( - y + ((y*d)*ones(1,N))))).^2))/T)';
    
    x = ((c - y - ones(T,1)*mu(:,ii)' -((ones(T,1)*lambda(:,ii)').*( - y + ((y*d)*ones(1,N)))))./(ones(T,1)*sigma(:,ii)'));
    
    L(ii,1) = -sum(sum(x.^2))/2 - T*sum(log(sigma(:,ii))) - (N*T*log(2*pi))/2;
    L(ii,1) = L(ii,1);
    
    l(:,ii) = (-sum(x.^2)/2 - T*log(sigma(:,ii)') - T*log(2*pi)/2)';
    
    if no_mu == 1
        para_out(:,ii) = [lambda(:,ii);sigma(:,ii)];
    else para_out(:,ii) = [lambda(:,ii);sigma(:,ii);mu(:,ii)];
    end
    
    %% Term-byterm checks on calculation
    if check_l == 1;
        sum_d = zeros(N,1);
        x_check = zeros(T,N);
        
        for k = 1 : N
            for t = 1 : T
                
                for j = 1 : N
                    sum_d(j,1) = d(j,1)*y(t,j);
                end
                
                x_check(t,k) = ((c(t,k) - y(t,k) - mu(k,ii) - lambda(k,ii)*( - y(t,k) + sum(sum_d)))/sigma(k,ii));
            end
        end
        
        L_check(ii,1) = -N*T*log(2*pi)/2 - sum(sum(x_check.^2))/2 - T*sum(log(sigma(:,ii)));
        
        mu_check = zeros(N,M);
        sigma_sq_check = mu_check;
        
        temp_z1 = y*d;
        
        for k = 1 : N
            for t = 1 : T
                mu_check(k,ii)  = mu_check(k,ii) + c(t,k) - y(t,k) - lambda(k,ii)*( - y(t,k) + temp_z1(t,1));
            end
            mu_check(k,ii) = mu_check(k,ii)/T;
            %mu_check(k,ii) = sum(c(:,k) - y(:,k) - lambda(k,1)*(- y(:,k) + y*d))/T;
            sigma_sq_check(k,ii) = sum((c(:,k) - y(:,k) - mu(k,ii) - lambda(k,ii)*( - y(:,k) + y*d)).^2)/T;
        end
        sigma_check(:,ii) = sqrt(sigma_sq_check(:,ii));
    end
end

end %End of the main function
